from math import hypot
from .lineq import linEq2

def circle3(c1, c2, c3):
    "Find circle passing through 3 noncollinear points, in 2D."
    x1 = c2[0] - c1[0]
    y1 = c2[1] - c1[1]
    x2 = c3[0] - c1[0]
    y2 = c3[1] - c1[1]
    xc, yc = linEq2(2.0*x1, 2.0*y1, x1**2+y1**2, 2.0*x2, 2.0*y2, x2**2+y2**2)
    if xc is None: return None, None   #Points are collinear
    r = hypot(xc, yc)
    cc = list(c1)
    cc[0] += xc
    cc[1] += yc
    return cc, r
