    def create_geometry(self, state):
        "Create grid; direction theta with respect to x-axis, varied widths,lenths of O.T. varies lengths of roads."
        self.roadsx = self.create_roads(state.theta, state.boik, state.bod)
        self.roadsy = self.create_roads(state.theta-pi*0.5, state.hoik, state.bod)
        self.roads = self.roadsx+self.roadsy


    def energy(self):
        "Calculates the energy of the system or the difference to the ideal configuration."
        sd = e = 0.0
        d8 = 0.0
        d10 = 0.0
        for cc, pyaxis, col in self.roads:
            if col != "green": continue
            for ca, cb in iterby2(cc):
                d = hypot(cb[0]-ca[0], cb[1]-ca[1])
                sd += d
                dz = fabs(cb[2]-ca[2])
                slope = dz*100.0/d
                if slope <= 8.0:
                    e += 0.0
                if dz < 10.0:
                    e += d*self.w1*(slope-8.0)
                    d8 += d
                else:
                    e += d*self.w1*(slope-8.0) + d*self.w2*(slope-10.0)
                    d10 += d
        e /= sd
        print ">8% length=", d8, "   >10% length=", d10
        return e

    def create_roads(self, theta, boik, bod):
        "Create grid; direction theta with respect to x-axis, varied widths,lenths of O.T. varies lengths of roads."
        t = cos(theta), sin(theta)
        n = -t[1], t[0]
        px = [t[0]*c[0]+t[1]*c[1] for c in self.hull]
        py = [n[0]*c[0]+n[1]*c[1] for c in self.hull]
        pxmin = min(px)
        pxmax = max(px)
        pymin = min(py)
        pymax = max(py)

        py = pymin
        j = jj = 0
        roads = []
        while True:
            pyaxis = py + bod[jj]*0.5
            if pyaxis >= pymax: break
            c1, c2 = thanPolygonLine(self.hull, pyaxis, n)
            assert c1 != None, "There should be 2 intersections!"
            nc, cprof = self.dtm.thanLineZ((c1, c2))
            col = "green"
            if nc == -1:
                print "Not one intersection with road!"
                col = "white"
                roads.append(((c1, c2), pyaxis, col))
            else:
                roads.append((cprof, pyaxis, col))
            py += bod[jj] + boik[jj]
            j += 1
            if j < len(bod): jj = j
        return roads
