# -*- coding: iso-8859-7 -*-
from math import pi
import p_ggeod, p_gearth
p = p_ggeod.UTMercator(zone=34)


def mantzoy():
    a = "13_2OS_OROFOS"
    annasmantzoy13 = [ 743105.000,    4207104.000,          173.000]
    lam, phi = p.en2geodetGRS80(*annasmantzoy13[:2])

    x, y = p_ggeod.egsa87.geodetGRS802en(lam, phi)
    print("%-20s%15.3f%15.3f%15.3f" % (a, x, y, 173))
    return a, lam, phi, 173


def damasippoy():
    a = "DAMASIPPOY13_4OS_OROFOS"
    damasippoy13a = [ 742489.000,    4207111.000,          144.000]   #Geomtric elevation
    damasippoy13b = [ 742488.000,    4207107.000,          112.000]   #Orthometric elevation
    damasippoy13 = [(damasippoy13a[0]+damasippoy13b[0])/2, (damasippoy13a[1]+damasippoy13b[1])/2, damasippoy13a[2]]
    lam, phi = p.en2geodetGRS80(*damasippoy13[:2])
    x, y = p_ggeod.egsa87.geodetGRS802en(lam, phi)
    print("%-20s%15.3f%15.3f%15.3f" % (a, x, y, damasippoy13[2]))
    hgme = p_gearth.egm08Ndyn(lam*180.0/pi, phi*180.0/pi) #Undulation of GRS80 ellipsoid
    print("hgme=", hgme)
    ha, hb = damasippoy13a[2]-hgme, damasippoy13b[2]
    h = (ha+hb)/2
    print("elevs",ha, hb, h)
    return a, lam, phi, h


fw = open("points.syn", "w")
for a, lam, phi, h in (mantzoy(), damasippoy()):
    fw.write("%-20s%25.15e%25.15e%15.3f\n" % (a, lam, phi, h))
fw.close()
