#!/usr/bin/python
from anneal import SimulatedAnnealing
from room import RoomConfiguration


def pyMain():
    "Main routine of standalone program."
    rc = RoomConfiguration(15.0, 10.0)
    sa = SimulatedAnnealing()
    sa.anneal(rc)
    print"final energy=", rc.energyState()
    rc.plot("Final Diaryqmish")


def thancadMain(proj):
    "Main routine of embedded program to ThanCad."
    def prt(s): proj[2].thanCom.thanAppend(s+"\n", "info1")
    def prtbo(s): proj[2].thanCom.thanAppend(s+"\n", "info")
    def prter(s): proj[2].thanCom.thanAppend(s+"\n", "can")
    rc = RoomConfiguration(15.0, 10.0, prt)
    sa = SimulatedAnnealing(prt)
    sa.anneal(rc)
    prtbo("final energy=%s" % (rc.energyState(),))
    rc.plot("Final Diaryqmish")
#    rc.plot2thancad(proj)


if __name__ == "__main__": pyMain()
