#!/usr/bin/python
from anneal import SimulatedAnnealing
from room import RoomConfiguration


def pyMain():
    "Main routine of standalone program."
    rc = RoomConfiguration(0.0, 0.0, 15.0, 10.0)
    sa = SimulatedAnnealing()
    sa.anneal(rc)
    print"final energy=", rc.energyState()
    rc.plot("Final Diaryqmish")


def thancadMain(proj, br=15.0, hr=10.0, nrooms=5, xor=200.0, yor=200.0):
    "Main routine of embedded program to ThanCad."
    def prt(s): proj[2].thanCom.thanAppend(s+"\n", "info1")
    def prtbo(s): proj[2].thanCom.thanAppend(s+"\n", "info")
    def prter(s): proj[2].thanCom.thanAppend(s+"\n", "can")
    rc = RoomConfiguration(xor, yor, br, hr, nrooms, prt)
    sa = SimulatedAnnealing(prt)
    sa.anneal(rc)
    prtbo("final energy=%s" % (rc.energyState(),))
#   rc.plot("Final Diaryqmish")
    rc.plot2(proj)


if __name__ == "__main__": pyMain()
