#!/usr/bin/python
import p_ggen
from anneal import SimulatedAnnealing
from room import RoomConfiguration
from constrain import RoomConstrain, RoomConfigurationConstrain


def pyMain():
    "Main routine of standalone program."
    v = p_ggen.Struct()
    v.entWidth = 9.0
    v.entHeight = 7.0
    v.entMinRooms = 5
    v.entMaxRooms = 6

    v.entMintolWidth = 2.5
    v.entMinWidth = 3.0
    v.entMaxWidth = 6.0
    v.entMaxtolWidth = 7.0
    v.entMintolHeight = 3.0
    v.entMinHeight = 3.0
    v.entMaxHeight = 7.0
    v.entMaxtolHeight = 8.0

    v.entPenaltmore = 1.0
    v.entPenalt1 = 10.0
    v.entPenalty = 1.0

    rcon = RoomConstrain(v.entMintolWidth , v.entMinWidth, v.entMaxWidth, v.entMaxtolWidth,
                         v.entMintolHeight, v.entMinHeight, v.entMaxHeight, v.entMaxtolHeight,
                         v.entPenalt1, v.entPenalty)
    ccon = RoomConfigurationConstrain(v.entMinRooms, v.entMaxRooms, v.entPenaltmore)
    rc = RoomConfiguration(0.0, 0.0, v.entWidth, v.entHeight, ccon, rcon)
    sa = SimulatedAnnealing()
    sa.anneal(rc)
    print"final energy=", rc.energyState()
    rc.plot("Final Diaryqmish")


def thancadMain(proj, v, xor, yor):
    "Main routine of embedded program to ThanCad."
    rcon = RoomConstrain(v.entMintolWidth,  v.entMinWidth,  v.entMaxWidth,  v.entMaxtolWidth,
                         v.entMintolHeight, v.entMinHeight, v.entMaxHeight, v.entMaxtolHeight,
                         v.entPenalt1, v.entPenalty)
    ccon = RoomConfigurationConstrain(v.entMinRooms, v.entMaxRooms, v.entPenaltmore)
    rc = RoomConfiguration(xor, yor, v.entWidth, v.entHeight, ccon, rcon, proj[2].thanPrt)
    sa = SimulatedAnnealing(proj[2].thanPrt)
    sa.anneal(rc)
    proj[2].thanPrtbo("final energy=%s" % (rc.energyState(),))
#   rc.plot("Final Diaryqmish")
    rc.plot2(proj)


if __name__ == "__main__": pyMain()
