# -*- coding: iso-8859-7 -*-
import Tkinter
import p_gtkwid, p_gtkuti
import urbantrans
Twid = p_gtkwid.Twid
T = urbantrans.Turban

roadW = 10.00
pavLeftW = 1.20
pavRightW = 1.00
medW = 0.0
valuesOk = False

top = None
entRoadW = None
entPavLeftW = None
entPavRightW = None
entMedW = None


def test():
    "Test the dialog."
    root = Tkinter.Tk()
    makeWidgets(root)
    setWidgets()
    root.wait_window(top)
    print valuesOk
    T.thanReport()


def makeWidgets(root):
    "Make the widgets of the dialog."
    global top, entRoadW, entPavLeftW, entPavRightW, entMedW 
    top = Tkinter.Toplevel(root)
    lab = Tkinter.Label(top, text=T["Road width (m)"])
    lab.grid(row=0, column=0, sticky="e")
    entRoadW = p_gtkwid.ThanEntry(top)
    entRoadW.grid(row=0, column=1, sticky="w")
    lab = Tkinter.Label(top, text=T["Left Pavement width (m)"])
    lab.grid(row=1, column=0, sticky="e")
    entPavLeftW = p_gtkwid.ThanEntry(top)
    entPavLeftW.grid(row=1, column=1, sticky="w")
    lab = Tkinter.Label(top, text=T["Right Pavement width (m)"])
    lab.grid(row=2, column=0, sticky="e")
    entPavRightW = p_gtkwid.ThanEntry(top)
    entPavRightW.grid(row=2, column=1, sticky="w")
    lab = Tkinter.Label(top, text=T["Median strip width (m)"])
    lab.grid(row=3, column=0, sticky="e")
    entMedW = p_gtkwid.ThanEntry(top)
    entMedW.grid(row=3, column=1, sticky="w")
    but = p_gtkwid.Button(top, text=Twid["OK"], command=pressedOk, bg="lightcyan", activebackground="cyan")
    but.grid(row=10, column=0, sticky="w")
    but = p_gtkwid.Button(top, text=Twid["Cancel"], command=pressedCan, bg="lightcyan", activebackground="cyan")
    but.grid(row=10, column=1, sticky="e")


def setWidgets():
    "Set default values to the widgets."
    entRoadW.thanSet(roadW)
    entPavLeftW.thanSet(pavLeftW)
    entPavRightW.thanSet(pavRightW)
    entMedW.thanSet(medW)


def object2Dialog(obj):
    "Get the values from an object."
    global roadW, pavLeftW, pavRightW, medW
    roadW     = obj.roadW
    pavLeftW  = obj.pavLeftW
    pavRightW = obj.pavRightW
    medW      = obj.medW


def dialog2Object(obj):
    "Set the values to an object."
    obj.roadW     = roadW
    obj.pavLeftW  = pavLeftW
    obj.pavRightW = pavRightW
    obj.medW      = medW


def pressedOk():
    "User pressed ok; check values."
    global roadW, pavLeftW, pavRightW, medW, valuesOk
    try:
        v = float(entRoadW.thanGet())
        if v <= 0: raise ValueError, T["A positive number was expected"]
    except Exception, e:
        p_gtkuti.thanGudModalMessage(top, message=e, title=T["Invalid width"], icon=p_gtkuti.ERROR)
        entRoadW.focus_set()
        return
    roadW = v
    try:
        v = float(entPavLeftW.thanGet())
        if v < 0: raise ValueError, T["A non negative number was expected"]
    except Exception, e:
        p_gtkuti.thanGudModalMessage(top, message=e, title=T["Invalid width"], icon=p_gtkuti.ERROR)
        entPavLeftW.focus_set()
        return
    pavLeftW = v
    try:
        v = float(entPavRightW.thanGet())
        if v < 0: raise ValueError, T["A non negative number was expected"]
    except Exception, e:
        p_gtkuti.thanGudModalMessage(top, message=e, title=T["Invalid width"], icon=p_gtkuti.ERROR)
        entPavRightW.focus_set()
        return
    pavRightW = v
    try:
        v = float(entMedW.thanGet())
        if v < 0: raise ValueError, T["A non negative number was expected"]
    except Exception, e:
        p_gtkuti.thanGudModalMessage(top, message=e, title=T["Invalid width"], icon=p_gtkuti.ERROR)
        entMedW.focus_set()
        return
    medW = v
    valuesOk = True
    top.destroy()


def pressedCan():
    "User pressed cancel; check values."
    global valuesOk
    ans = p_gtkuti.thanGudAskYesNo(top, message=T["Are you sure to lose all values?"], title=T["Cancel"], default="no")
    if ans:
        valuesOk = False
        top.destroy()

if __name__ == "__main__":
    test()
