def thanEngLineprofile(proj):
    "Creates a (3D) line profile into a new drawing."
    from thanimp import ThanCadDrSave
    from thansupport import ThanDxfEmu
    from thancomview import thanZoomExt
    from thancomfile import thanFileNewDo
    proj[2].thanCom.thanAppend(T["Select 3d lines to make profiles:\n"], "info1")
    res = thancomsel.thanSelectGen(proj, standalone=False, filter=lambda e: isinstance(e, thandr.ThanLine))
    if res == Canc: return thanModCanc(proj)           # Profile was cancelled
    dfact = 0.1
    for e in proj[2].thanSelall:
        d = [0.0*dfact]
        for ca, cb in p_ggen.iterby2(e.cp):
            d.append(d[-1]+hypot(cb[1]-ca[1], cb[0]-ca[0])*dfact)
        zmin = min(ca[2] for ca in e.cp)
        projnew = thanFileNewDo(proj)
        ts = ThanCadDrSave(projnew[1], lambda s: projnew[2].thanCom.thanAppend("%s\n" % s))
        dxf = ThanDxfEmu()
        dxf.thanDxfPlots(ts)
        dxf.thanDxfPlot(d[0],  zmin, 3)
        dxf.thanDxfPlot(d[-1], zmin, 2)
        dxf.thanDxfPlot(d[0],  zmin, 3)
        dxf.thanDxfPlot(d[0],  e.cp[0][2], 2)
        for i in xrange(1, len(e.cp)):
            dxf.thanDxfPlot(d[i],   zmin,         3)
            dxf.thanDxfPlot(d[i],   e.cp[i][2],   2)
            dxf.thanDxfPlot(d[i-1], e.cp[i-1][2], 2)
        dxf.thanDxfPlot(0, 0, 999)
        projnew[1].thanLayerTree.thanDictRebuild()
        projnew[2].thanRegen()
        thanZoomExt(projnew)
    return thanModEnd(proj, T["%d profiles were created."]%len(proj[2].thanSelall), "info")
