##############################################################################
# ThanCad 0.6.0 "Students2021": n-dimensional CAD with raster support for engineers
# 
# Copyright (C) 2001-2021 Thanasis Stamos, October 5, 2021
# Athens, Greece, Europe
# URL: http://thancad.sourceforge.net
# e-mail: cyberthanasis@excite.com
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details (www.gnu.org/licenses/gpl.html).
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##############################################################################
"""\
ThanCad 0.6.0 "Students2021": n-dimensional CAD with raster support for engineers

It implements various constants for the TkGui of ThanCad.
"""

import enum


class THAN_STATE(enum.Enum):
    NONE      = enum.auto()
    INTERRUPT = enum.auto()
    POINT     = enum.auto()
    POINT1    = enum.auto()
    LINE      = enum.auto()
    LINE2     = enum.auto()
    POLAR     = enum.auto()
    CIRCLE    = enum.auto()
    CIRCLE2   = enum.auto()
    CIRCLE3   = enum.auto()
    ARC       = enum.auto()
    RECTANGLE = enum.auto()
    RECTRATIO = enum.auto()
    TEXT      = enum.auto()
    MOVE      = enum.auto()
    ROADP     = enum.auto()
    ROADR     = enum.auto()
    SPLINEP   = enum.auto()
    ELLIPSEB  = enum.auto()
    SNAPELEM  = enum.auto()
    #UNFOCUSED = enum.auto()

    DRAGFOLLOWS = enum.auto()    # Drom this state on, all states are for dragging

    PANDYNAMIC  = enum.auto()
    ZOOMDYNAMIC = enum.auto()

    DRAG2BEGIN = enum.auto()
    DRAGFIRST  = enum.auto()
    DRAGGING   = enum.auto()

thanCursor = {
#               THAN_STATE.SELECT1    : "dot",
#               THAN_STATE.SELECT1    : "center_ptr",
#               THAN_STATE.SELECT1    : "draped_box",
#               THAN_STATE.SELECT1    : "middlebutton",
#               THAN_STATE.SELECT1    : "target",
#               THAN_STATE.SELECT1    : "gobbler",
#               THAN_STATE.SELECT1    : "gumby",
               THAN_STATE.POINT1     : "dotbox",
               THAN_STATE.PANDYNAMIC : "hand2",
               THAN_STATE.ZOOMDYNAMIC: "sb_h_double_arrow"
             }

if __name__ == "__main__":
    print(__doc__)
